import type { Comparator } from "@rickosborne/typical";
import type { Queue } from "./queue.js";
/**
 * An implementation of a priority queue backed by a JS array,
 * using the given comparator.  Sorts low-to-high, so you will
 * need to invert comparator if you want high-to-low.
 */
export declare class PriorityArray<T> implements Queue<T> {
    private readonly comparator;
    private readonly items;
    constructor(comparator: Comparator<T>);
    get [Symbol.toStringTag](): string;
    get length(): number;
    add(value: T): void;
    peek(): T | undefined;
    remove(item: T): void;
    take(): T | undefined;
    toArray(): T[];
    values(): Generator<T, void, undefined>;
}
//# sourceMappingURL=priority-array.d.ts.map