import type { Comparator } from "@rickosborne/typical";
import type { Queue } from "./queue.js";
/**
 * Implementation of a priority queue backed by a linked list,
 * using the given comparator.  Sorts low-to-high, so you will
 * need to invert comparator if you want high-to-low.
 */
export declare class PriorityLinkedList<T> implements Queue<T> {
    private readonly comparator;
    private readonly list;
    constructor(comparator: Comparator<T>);
    get length(): number;
    add(item: T): void;
    peek(): T | undefined;
    remove(item: T): void;
    take(): T | undefined;
    toArray(): T[];
    values(): Generator<T, void, undefined>;
}
//# sourceMappingURL=priority-linked-list.d.ts.map